// Downloaded from https://repo.progsbase.com - Code Developed Using progsbase.

function AddNumber(list, a){
  var newlist;
  var i;

  newlist = [];
  newlist.length = list.length + 1;
  for(i = 0; i < list.length; i = i + 1){
    newlist[i] = list[i];
  }
  newlist[list.length] = a;
		
  delete(list);
		
  return newlist;
}
function AddNumberRef(list, i){
  list.numberArray = AddNumber(list.numberArray, i);
}
function RemoveNumber(list, n){
  var newlist;
  var i;

  newlist = [];
  newlist.length = list.length - 1;

  if(n >= 0 && n < list.length){
    for(i = 0; i < list.length; i = i + 1){
      if(i < n){
        newlist[i] = list[i];
      }
      if(i > n){
        newlist[i - 1] = list[i];
      }
    }

    delete(list);
  }else{
    delete(newlist);
  }
		
  return newlist;
}
function GetNumberRef(list, i){
  return list.numberArray[i];
}
function RemoveNumberRef(list, i){
  list.numberArray = RemoveNumber(list.numberArray, i);
}
function AddString(list, a){
  var newlist;
  var i;

  newlist = [];
  newlist.length = list.length + 1;

  for(i = 0; i < list.length; i = i + 1){
    newlist[i] = list[i];
  }
  newlist[list.length] = a;
		
  delete(list);
		
  return newlist;
}
function AddStringRef(list, i){
  list.stringArray = AddString(list.stringArray, i);
}
function RemoveString(list, n){
  var newlist;
  var i;

  newlist = [];
  newlist.length = list.length - 1;

  if(n >= 0 && n < list.length){
    for(i = 0; i < list.length; i = i + 1){
      if(i < n){
        newlist[i] = list[i];
      }
      if(i > n){
        newlist[i - 1] = list[i];
      }
    }

    delete(list);
  }else{
    delete(newlist);
  }
		
  return newlist;
}
function GetStringRef(list, i){
  return list.stringArray[i];
}
function RemoveStringRef(list, i){
  list.stringArray = RemoveString(list.stringArray, i);
}
function CreateDynamicArrayCharacters(){
  var da;

  da = {};
  da.array = [];
  da.array.length = 10;
  da.lengthx = 0;

  return da;
}
function CreateDynamicArrayCharactersWithInitialCapacity(capacity){
  var da;

  da = {};
  da.array = [];
  da.array.length = capacity;
  da.lengthx = 0;

  return da;
}
function DynamicArrayAddCharacter(da, value){
  if(da.lengthx == da.array.length){
    DynamicArrayCharactersIncreaseSize(da);
  }

  da.array[da.lengthx] = value;
  da.lengthx = da.lengthx + 1;
}
function DynamicArrayAddString(da, str){
  var i;

  for(i = 0; i < str.length; i = i + 1){
    DynamicArrayAddCharacter(da, str[i]);
  }
}
function DynamicArrayCharactersIncreaseSize(da){
  var newLength, i;
  var newArray;

  newLength = Math.round(da.array.length*3/2);
  newArray = [];
  newArray.length = newLength;

  for(i = 0; i < da.array.length; i = i + 1){
    newArray[i] = da.array[i];
  }

  delete(da.array);

  da.array = newArray;
}
function DynamicArrayCharactersDecreaseSizeNecessary(da){
  var needsDecrease;

  needsDecrease = false;

  if(da.lengthx > 10){
    needsDecrease = da.lengthx <= Math.round(da.array.length*2/3);
  }

  return needsDecrease;
}
function DynamicArrayCharactersDecreaseSize(da){
  var newLength, i;
  var newArray;

  newLength = Math.round(da.array.length*2/3);
  newArray = [];
  newArray.length = newLength;

  for(i = 0; i < newLength; i = i + 1){
    newArray[i] = da.array[i];
  }

  delete(da.array);

  da.array = newArray;
}
function DynamicArrayCharactersIndex(da, index){
  return da.array[index];
}
function DynamicArrayCharactersLength(da){
  return da.lengthx;
}
function DynamicArrayInsertCharacter(da, index, value){
  var i;

  if(da.lengthx == da.array.length){
    DynamicArrayCharactersIncreaseSize(da);
  }

  for(i = da.lengthx; i > index; i = i - 1){
    da.array[i] = da.array[i - 1];
  }

  da.array[index] = value;

  da.lengthx = da.lengthx + 1;
}
function DynamicArrayCharacterSet(da, index, value){
  var success;

  if(index < da.lengthx){
    da.array[index] = value;
    success = true;
  }else{
    success = false;
  }

  return success;
}
function DynamicArrayRemoveCharacter(da, index){
  var i;

  for(i = index; i < da.lengthx - 1; i = i + 1){
    da.array[i] = da.array[i + 1];
  }

  da.lengthx = da.lengthx - 1;

  if(DynamicArrayCharactersDecreaseSizeNecessary(da)){
    DynamicArrayCharactersDecreaseSize(da);
  }
}
function FreeDynamicArrayCharacters(da){
  delete(da.array);
  delete(da);
}
function DynamicArrayCharactersToArray(da){
  var array;
  var i;

  array = [];
  array.length = da.lengthx;

  for(i = 0; i < da.lengthx; i = i + 1){
    array[i] = da.array[i];
  }

  return array;
}
function ArrayToDynamicArrayCharactersWithOptimalSize(array){
  var da;
  var i;
  var c, n, newCapacity;

  c = array.length;
  n = (Math.log(c) - 1)/Math.log(3/2);
  newCapacity = Math.ceil(10*Math.pow(3/2, n));

  da = CreateDynamicArrayCharactersWithInitialCapacity(newCapacity);

  for(i = 0; i < array.length; i = i + 1){
    da.array[i] = array[i];
  }

  return da;
}
function ArrayToDynamicArrayCharacters(array){
  var da;

  da = {};
  da.array = CopyString(array);
  da.lengthx = array.length;

  return da;
}
function DynamicArrayCharactersEqual(a, b){
  var equal;
  var i;

  equal = true;
  if(a.lengthx == b.lengthx){
    for(i = 0; i < a.lengthx && equal; i = i + 1){
      if(a.array[i] != b.array[i]){
        equal = false;
      }
    }
  }else{
    equal = false;
  }

  return equal;
}
function DynamicArrayCharactersToLinkedList(da){
  var ll;
  var i;

  ll = CreateLinkedListCharacter();

  for(i = 0; i < da.lengthx; i = i + 1){
    LinkedListAddCharacter(ll, da.array[i]);
  }

  return ll;
}
function LinkedListToDynamicArrayCharacters(ll){
  var da;
  var i;
  var node;

  node = ll.first;

  da = {};
  da.lengthx = LinkedListCharactersLength(ll);

  da.array = [];
  da.array.length = da.lengthx;

  for(i = 0; i < da.lengthx; i = i + 1){
    da.array[i] = node.value;
    node = node.next;
  }

  return da;
}
function AddBoolean(list, a){
  var newlist;
  var i;

  newlist = [];
  newlist.length = list.length + 1;
  for(i = 0; i < list.length; i = i + 1){
    newlist[i] = list[i];
  }
  newlist[list.length] = a;
		
  delete(list);
		
  return newlist;
}
function AddBooleanRef(list, i){
  list.booleanArray = AddBoolean(list.booleanArray, i);
}
function RemoveBoolean(list, n){
  var newlist;
  var i;

  newlist = [];
  newlist.length = list.length - 1;

  if(n >= 0 && n < list.length){
    for(i = 0; i < list.length; i = i + 1){
      if(i < n){
        newlist[i] = list[i];
      }
      if(i > n){
        newlist[i - 1] = list[i];
      }
    }

    delete(list);
  }else{
    delete(newlist);
  }
		
  return newlist;
}
function GetBooleanRef(list, i){
  return list.booleanArray[i];
}
function RemoveDecimalRef(list, i){
  list.booleanArray = RemoveBoolean(list.booleanArray, i);
}
function CreateLinkedListString(){
  var ll;

  ll = {};
  ll.first = {};
  ll.last = ll.first;
  ll.last.end = true;

  return ll;
}
function LinkedListAddString(ll, value){
  ll.last.end = false;
  ll.last.value = value;
  ll.last.next = {};
  ll.last.next.end = true;
  ll.last = ll.last.next;
}
function LinkedListStringsToArray(ll){
  var array;
  var lengthx, i;
  var node;

  node = ll.first;

  lengthx = LinkedListStringsLength(ll);

  array = [];
  array.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    array[i] = {};
    array[i].string = node.value;
    node = node.next;
  }

  return array;
}
function LinkedListStringsLength(ll){
  var l;
  var node;

  l = 0;
  node = ll.first;
  for(;  !node.end ; ){
    node = node.next;
    l = l + 1;
  }

  return l;
}
function FreeLinkedListString(ll){
  var node, prev;

  node = ll.first;

  for(;  !node.end ; ){
    prev = node;
    node = node.next;
    delete(prev);
  }

  delete(node);
}
function LinkedListInsertString(ll, index, value){
  var i;
  var node, tmp;

  if(index == 0){
    tmp = ll.first;
    ll.first = {};
    ll.first.next = tmp;
    ll.first.value = value;
    ll.first.end = false;
  }else{
    node = ll.first;
    for(i = 0; i < index - 1; i = i + 1){
      node = node.next;
    }

    tmp = node.next;
    node.next = {};
    node.next.next = tmp;
    node.next.value = value;
    node.next.end = false;
  }
}
function CreateLinkedListNumbers(){
  var ll;

  ll = {};
  ll.first = {};
  ll.last = ll.first;
  ll.last.end = true;

  return ll;
}
function CreateLinkedListNumbersArray(lengthx){
  var lls;
  var i;

  lls = [];
  lls.length = lengthx;
  for(i = 0; i < lls.length; i = i + 1){
    lls[i] = CreateLinkedListNumbers();
  }

  return lls;
}
function LinkedListAddNumber(ll, value){
  ll.last.end = false;
  ll.last.value = value;
  ll.last.next = {};
  ll.last.next.end = true;
  ll.last = ll.last.next;
}
function LinkedListNumbersLength(ll){
  var l;
  var node;

  l = 0;
  node = ll.first;
  for(;  !node.end ; ){
    node = node.next;
    l = l + 1;
  }

  return l;
}
function LinkedListNumbersIndex(ll, index){
  var i;
  var node;

  node = ll.first;
  for(i = 0; i < index; i = i + 1){
    node = node.next;
  }

  return node.value;
}
function LinkedListInsertNumber(ll, index, value){
  var i;
  var node, tmp;

  if(index == 0){
    tmp = ll.first;
    ll.first = {};
    ll.first.next = tmp;
    ll.first.value = value;
    ll.first.end = false;
  }else{
    node = ll.first;
    for(i = 0; i < index - 1; i = i + 1){
      node = node.next;
    }

    tmp = node.next;
    node.next = {};
    node.next.next = tmp;
    node.next.value = value;
    node.next.end = false;
  }
}
function LinkedListSet(ll, index, value){
  var i;
  var node;

  node = ll.first;
  for(i = 0; i < index; i = i + 1){
    node = node.next;
  }

  node.next.value = value;
}
function LinkedListRemoveNumber(ll, index){
  var i;
  var node, prev;

  node = ll.first;
  prev = ll.first;

  for(i = 0; i < index; i = i + 1){
    prev = node;
    node = node.next;
  }

  if(index == 0){
    ll.first = prev.next;
  }
  if( !prev.next.end ){
    prev.next = prev.next.next;
  }
}
function FreeLinkedListNumbers(ll){
  var node, prev;

  node = ll.first;

  for(;  !node.end ; ){
    prev = node;
    node = node.next;
    delete(prev);
  }

  delete(node);
}
function FreeLinkedListNumbersArray(lls){
  var i;

  for(i = 0; i < lls.length; i = i + 1){
    FreeLinkedListNumbers(lls[i]);
  }
  delete(lls);
}
function LinkedListNumbersToArray(ll){
  var array;
  var lengthx, i;
  var node;

  node = ll.first;

  lengthx = LinkedListNumbersLength(ll);

  array = [];
  array.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    array[i] = node.value;
    node = node.next;
  }

  return array;
}
function ArrayToLinkedListNumbers(array){
  var ll;
  var i;

  ll = CreateLinkedListNumbers();

  for(i = 0; i < array.length; i = i + 1){
    LinkedListAddNumber(ll, array[i]);
  }

  return ll;
}
function LinkedListNumbersEqual(a, b){
  var equal, done;
  var an, bn;

  an = a.first;
  bn = b.first;

  equal = true;
  done = false;
  for(; equal &&  !done ; ){
    if(an.end == bn.end){
      if(an.end){
        done = true;
      }else if(an.value == bn.value){
        an = an.next;
        bn = bn.next;
      }else{
        equal = false;
      }
    }else{
      equal = false;
    }
  }

  return equal;
}
function CreateLinkedListCharacter(){
  var ll;

  ll = {};
  ll.first = {};
  ll.last = ll.first;
  ll.last.end = true;

  return ll;
}
function LinkedListAddCharacter(ll, value){
  ll.last.end = false;
  ll.last.value = value;
  ll.last.next = {};
  ll.last.next.end = true;
  ll.last = ll.last.next;
}
function LinkedListCharactersToArray(ll){
  var array;
  var lengthx, i;
  var node;

  node = ll.first;

  lengthx = LinkedListCharactersLength(ll);

  array = [];
  array.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    array[i] = node.value;
    node = node.next;
  }

  return array;
}
function LinkedListCharactersLength(ll){
  var l;
  var node;

  l = 0;
  node = ll.first;
  for(;  !node.end ; ){
    node = node.next;
    l = l + 1;
  }

  return l;
}
function FreeLinkedListCharacter(ll){
  var node, prev;

  node = ll.first;

  for(;  !node.end ; ){
    prev = node;
    node = node.next;
    delete(prev);
  }

  delete(node);
}
function LinkedListCharactersAddString(ll, str){
  var i;

  for(i = 0; i < str.length; i = i + 1){
    LinkedListAddCharacter(ll, str[i]);
  }
}
function LinkedListInsertCharacter(ll, index, value){
  var i;
  var node, tmp;

  if(index == 0){
    tmp = ll.first;
    ll.first = {};
    ll.first.next = tmp;
    ll.first.value = value;
    ll.first.end = false;
  }else{
    node = ll.first;
    for(i = 0; i < index - 1; i = i + 1){
      node = node.next;
    }

    tmp = node.next;
    node.next = {};
    node.next.next = tmp;
    node.next.value = value;
    node.next.end = false;
  }
}
function CreateDynamicArrayNumbers(){
  var da;

  da = {};
  da.array = [];
  da.array.length = 10;
  da.lengthx = 0;

  return da;
}
function CreateDynamicArrayNumbersWithInitialCapacity(capacity){
  var da;

  da = {};
  da.array = [];
  da.array.length = capacity;
  da.lengthx = 0;

  return da;
}
function DynamicArrayAddNumber(da, value){
  if(da.lengthx == da.array.length){
    DynamicArrayNumbersIncreaseSize(da);
  }

  da.array[da.lengthx] = value;
  da.lengthx = da.lengthx + 1;
}
function DynamicArrayNumbersIncreaseSize(da){
  var newLength, i;
  var newArray;

  newLength = Math.round(da.array.length*3/2);
  newArray = [];
  newArray.length = newLength;

  for(i = 0; i < da.array.length; i = i + 1){
    newArray[i] = da.array[i];
  }

  delete(da.array);

  da.array = newArray;
}
function DynamicArrayNumbersDecreaseSizeNecessary(da){
  var needsDecrease;

  needsDecrease = false;

  if(da.lengthx > 10){
    needsDecrease = da.lengthx <= Math.round(da.array.length*2/3);
  }

  return needsDecrease;
}
function DynamicArrayNumbersDecreaseSize(da){
  var newLength, i;
  var newArray;

  newLength = Math.round(da.array.length*2/3);
  newArray = [];
  newArray.length = newLength;

  for(i = 0; i < newLength; i = i + 1){
    newArray[i] = da.array[i];
  }

  delete(da.array);

  da.array = newArray;
}
function DynamicArrayNumbersIndex(da, index){
  return da.array[index];
}
function DynamicArrayNumbersLength(da){
  return da.lengthx;
}
function DynamicArrayInsertNumber(da, index, value){
  var i;

  if(da.lengthx == da.array.length){
    DynamicArrayNumbersIncreaseSize(da);
  }

  for(i = da.lengthx; i > index; i = i - 1){
    da.array[i] = da.array[i - 1];
  }

  da.array[index] = value;

  da.lengthx = da.lengthx + 1;
}
function DynamicArrayNumberSet(da, index, value){
  var success;

  if(index < da.lengthx){
    da.array[index] = value;
    success = true;
  }else{
    success = false;
  }

  return success;
}
function DynamicArrayRemoveNumber(da, index){
  var i;

  for(i = index; i < da.lengthx - 1; i = i + 1){
    da.array[i] = da.array[i + 1];
  }

  da.lengthx = da.lengthx - 1;

  if(DynamicArrayNumbersDecreaseSizeNecessary(da)){
    DynamicArrayNumbersDecreaseSize(da);
  }
}
function FreeDynamicArrayNumbers(da){
  delete(da.array);
  delete(da);
}
function DynamicArrayNumbersToArray(da){
  var array;
  var i;

  array = [];
  array.length = da.lengthx;

  for(i = 0; i < da.lengthx; i = i + 1){
    array[i] = da.array[i];
  }

  return array;
}
function ArrayToDynamicArrayNumbersWithOptimalSize(array){
  var da;
  var i;
  var c, n, newCapacity;

  /*
         c = 10*(3/2)^n
         log(c) = log(10*(3/2)^n)
         log(c) = log(10) + log((3/2)^n)
         log(c) = 1 + log((3/2)^n)
         log(c) - 1 = log((3/2)^n)
         log(c) - 1 = n*log(3/2)
         n = (log(c) - 1)/log(3/2)
         */
  c = array.length;
  n = (Math.log(c) - 1)/Math.log(3/2);
  newCapacity = Math.ceil(10*Math.pow(3/2, n));

  da = CreateDynamicArrayNumbersWithInitialCapacity(newCapacity);

  for(i = 0; i < array.length; i = i + 1){
    da.array[i] = array[i];
  }

  return da;
}
function ArrayToDynamicArrayNumbers(array){
  var da;

  da = {};
  da.array = CopyNumberArray(array);
  da.lengthx = array.length;

  return da;
}
function DynamicArrayNumbersEqual(a, b){
  var equal;
  var i;

  equal = true;
  if(a.lengthx == b.lengthx){
    for(i = 0; i < a.lengthx && equal; i = i + 1){
      if(a.array[i] != b.array[i]){
        equal = false;
      }
    }
  }else{
    equal = false;
  }

  return equal;
}
function DynamicArrayNumbersToLinkedList(da){
  var ll;
  var i;

  ll = CreateLinkedListNumbers();

  for(i = 0; i < da.lengthx; i = i + 1){
    LinkedListAddNumber(ll, da.array[i]);
  }

  return ll;
}
function LinkedListToDynamicArrayNumbers(ll){
  var da;
  var i;
  var node;

  node = ll.first;

  da = {};
  da.lengthx = LinkedListNumbersLength(ll);

  da.array = [];
  da.array.length = da.lengthx;

  for(i = 0; i < da.lengthx; i = i + 1){
    da.array[i] = node.value;
    node = node.next;
  }

  return da;
}
function DynamicArrayNumbersIndexOf(arr, n, foundReference){
  var found;
  var i;

  found = false;
  for(i = 0; i < arr.lengthx &&  !found ; i = i + 1){
    if(arr.array[i] == n){
      found = true;
    }
  }
  if( !found ){
    i =  -1;
  }else{
    i = i - 1;
  }

  foundReference.booleanValue = found;

  return i;
}
function DynamicArrayNumbersIsInArray(arr, n){
  var found;
  var i;

  found = false;
  for(i = 0; i < arr.lengthx &&  !found ; i = i + 1){
    if(arr.array[i] == n){
      found = true;
    }
  }

  return found;
}
function AddCharacter(list, a){
  var newlist;
  var i;

  newlist = [];
  newlist.length = list.length + 1;
  for(i = 0; i < list.length; i = i + 1){
    newlist[i] = list[i];
  }
  newlist[list.length] = a;
		
  delete(list);
		
  return newlist;
}
function AddCharacterRef(list, i){
  list.string = AddCharacter(list.string, i);
}
function RemoveCharacter(list, n){
  var newlist;
  var i;

  newlist = [];
  newlist.length = list.length - 1;

  if(n >= 0 && n < list.length){
    for(i = 0; i < list.length; i = i + 1){
      if(i < n){
        newlist[i] = list[i];
      }
      if(i > n){
        newlist[i - 1] = list[i];
      }
    }

    delete(list);
  }else{
    delete(newlist);
  }

  return newlist;
}
function GetCharacterRef(list, i){
  return list.string[i];
}
function RemoveCharacterRef(list, i){
  list.string = RemoveCharacter(list.string, i);
}
function testNumberList1(failures){
  var list;

  list = [];
  list.length = 0;
		
  list = AddNumber(list, 1);
  list = AddNumber(list, 2);
  list = AddNumber(list, 3);
		
  if(list[0] != 1){
    failures.numberValue = failures.numberValue + 1;
  }
  if(list[1] != 2){
    failures.numberValue = failures.numberValue + 1;
  }
  if(list[2] != 3){
    failures.numberValue = failures.numberValue + 1;
  }
		
  list = RemoveNumber(list, 1);
		
  if(list[0] != 1){
    failures.numberValue = failures.numberValue + 1;
  }
  if(list[1] != 3){
    failures.numberValue = failures.numberValue + 1;
  }
		
  delete(list);
}
function testNumberList2(failures){
  var list;

  list = {};
  list.numberArray = [];
  list.numberArray.length = 0;

  AddNumberRef(list, 1);
  AddNumberRef(list, 2);
  AddNumberRef(list, 3);

  if(GetNumberRef(list, 0) != 1){
    failures.numberValue = failures.numberValue + 1;
  }
  if(GetNumberRef(list, 1) != 2){
    failures.numberValue = failures.numberValue + 1;
  }
  if(GetNumberRef(list, 2) != 3){
    failures.numberValue = failures.numberValue + 1;
  }

  RemoveNumberRef(list, 1);

  if(GetNumberRef(list, 0) != 1){
    failures.numberValue = failures.numberValue + 1;
  }
  if(GetNumberRef(list, 1) != 3){
    failures.numberValue = failures.numberValue + 1;
  }

  delete(list);
}
function DynamicArrayTests(failures){
  TestDynamicArrayNumbersAdd(failures);
  TestDynamicArrayNumbersRemove1(failures);
  TestDynamicArrayNumbersRemove2(failures);
  TestDynamicArrayNumbersRemove3(failures);
  TestDynamicArrayNumbersInsert(failures);
  TestDynamicArrayNumbersEqualsAndConvert1(failures);
  TestDynamicArrayNumbersEqualsAndConvert2(failures);
  TestDynamicArrayNumbersEqualsAndConvert3(failures);
  TestDynamicArrayNumbersEqualsAndConvert4(failures);
}
function TestDynamicArrayNumbersAdd(failures){
  var da;

  da = CreateDynamicArrayNumbers();

  DynamicArrayAddNumber(da, 1);
  DynamicArrayAddNumber(da, 2);
  DynamicArrayAddNumber(da, 3);

  if(DynamicArrayNumbersLength(da) != 3){
    failures.numberValue = failures.numberValue + 1;
  }

  if(DynamicArrayNumbersIndex(da, 0) != 1){
    failures.numberValue = failures.numberValue + 1;
  }

  if(DynamicArrayNumbersIndex(da, 1) != 2){
    failures.numberValue = failures.numberValue + 1;
  }

  if(DynamicArrayNumbersIndex(da, 2) != 3){
    failures.numberValue = failures.numberValue + 1;
  }

  FreeDynamicArrayNumbers(da);
}
function TestDynamicArrayNumbersRemove1(failures){
  var ll;

  ll = CreateDynamicArrayNumbers();

  DynamicArrayAddNumber(ll, 1);
  DynamicArrayAddNumber(ll, 2);
  DynamicArrayAddNumber(ll, 3);
  DynamicArrayRemoveNumber(ll, 2);

  if(DynamicArrayNumbersLength(ll) != 2){
    failures.numberValue = failures.numberValue + 1;
  }

  if(DynamicArrayNumbersIndex(ll, 0) != 1){
    failures.numberValue = failures.numberValue + 1;
  }

  if(DynamicArrayNumbersIndex(ll, 1) != 2){
    failures.numberValue = failures.numberValue + 1;
  }

  FreeDynamicArrayNumbers(ll);
}
function TestDynamicArrayNumbersRemove2(failures){
  var ll;

  ll = CreateDynamicArrayNumbers();

  DynamicArrayAddNumber(ll, 1);
  DynamicArrayAddNumber(ll, 2);
  DynamicArrayAddNumber(ll, 3);
  DynamicArrayRemoveNumber(ll, 1);

  if(DynamicArrayNumbersLength(ll) != 2){
    failures.numberValue = failures.numberValue + 1;
  }

  if(DynamicArrayNumbersIndex(ll, 0) != 1){
    failures.numberValue = failures.numberValue + 1;
  }

  if(DynamicArrayNumbersIndex(ll, 1) != 3){
    failures.numberValue = failures.numberValue + 1;
  }

  FreeDynamicArrayNumbers(ll);
}
function TestDynamicArrayNumbersRemove3(failures){
  var da;

  da = CreateDynamicArrayNumbers();

  DynamicArrayAddNumber(da, 1);
  DynamicArrayAddNumber(da, 2);
  DynamicArrayAddNumber(da, 3);
  DynamicArrayRemoveNumber(da, 0);
  DynamicArrayRemoveNumber(da, 1);
  DynamicArrayRemoveNumber(da, 0);

  if(DynamicArrayNumbersLength(da) != 0){
    failures.numberValue = failures.numberValue + 1;
  }

  FreeDynamicArrayNumbers(da);
}
function TestDynamicArrayNumbersInsert(failures){
  var da;

  da = CreateDynamicArrayNumbers();

  DynamicArrayInsertNumber(da, 0, 1);
  DynamicArrayInsertNumber(da, 0, 2);
  DynamicArrayInsertNumber(da, 0, 3);

  if(DynamicArrayNumbersLength(da) != 3){
    failures.numberValue = failures.numberValue + 1;
  }

  if(DynamicArrayNumbersIndex(da, 0) != 3){
    failures.numberValue = failures.numberValue + 1;
  }

  if(DynamicArrayNumbersIndex(da, 1) != 2){
    failures.numberValue = failures.numberValue + 1;
  }

  if(DynamicArrayNumbersIndex(da, 2) != 1){
    failures.numberValue = failures.numberValue + 1;
  }

  FreeDynamicArrayNumbers(da);
}
function TestDynamicArrayNumbersEqualsAndConvert1(failures){
  var a, b, newb;
  var aa, ba;
  var equal;

  a = CreateDynamicArrayNumbers();

  DynamicArrayInsertNumber(a, 0, 1);
  DynamicArrayInsertNumber(a, 0, 2);
  DynamicArrayInsertNumber(a, 0, 3);

  b = CreateDynamicArrayNumbers();

  DynamicArrayInsertNumber(b, 0, 3);
  DynamicArrayInsertNumber(b, 1, 2);
  DynamicArrayInsertNumber(b, 2, 1);

  equal = DynamicArrayNumbersEqual(a, b);

  if( !equal ){
    failures.numberValue = failures.numberValue + 1;
  }

  aa = DynamicArrayNumbersToArray(a);
  ba = DynamicArrayNumbersToArray(b);

  equal = NumberArraysEqual(aa, ba);

  if( !equal ){
    failures.numberValue = failures.numberValue + 1;
  }

  newb = ArrayToDynamicArrayNumbers(ba);

  equal = DynamicArrayNumbersEqual(a, newb);

  if( !equal ){
    failures.numberValue = failures.numberValue + 1;
  }
}
function TestDynamicArrayNumbersEqualsAndConvert2(failures){
  var a, b, newb;
  var aa, ba;
  var equal;

  a = CreateDynamicArrayNumbers();

  DynamicArrayInsertNumber(a, 0, 1);
  DynamicArrayInsertNumber(a, 0, 2);
  DynamicArrayInsertNumber(a, 0, 3);

  b = CreateDynamicArrayNumbers();

  DynamicArrayInsertNumber(b, 0, 3);
  DynamicArrayInsertNumber(b, 0, 2);
  DynamicArrayInsertNumber(b, 2, 1);

  equal = DynamicArrayNumbersEqual(a, b);

  if(equal){
    failures.numberValue = failures.numberValue + 1;
  }

  aa = DynamicArrayNumbersToArray(a);
  ba = DynamicArrayNumbersToArray(b);

  equal = NumberArraysEqual(aa, ba);

  if(equal){
    failures.numberValue = failures.numberValue + 1;
  }

  newb = ArrayToDynamicArrayNumbers(ba);

  equal = DynamicArrayNumbersEqual(a, newb);

  if(equal){
    failures.numberValue = failures.numberValue + 1;
  }
}
function TestDynamicArrayNumbersEqualsAndConvert3(failures){
  var a, b, newb;
  var aa, ba;
  var equal;

  a = CreateDynamicArrayNumbers();

  DynamicArrayInsertNumber(a, 0, 1);
  DynamicArrayInsertNumber(a, 0, 2);
  DynamicArrayInsertNumber(a, 0, 3);

  b = CreateDynamicArrayNumbers();

  DynamicArrayInsertNumber(b, 0, 3);
  DynamicArrayInsertNumber(b, 1, 2);
  DynamicArrayInsertNumber(b, 2, 1);

  equal = DynamicArrayNumbersEqual(a, b);

  if( !equal ){
    failures.numberValue = failures.numberValue + 1;
  }

  aa = DynamicArrayNumbersToLinkedList(a);
  ba = DynamicArrayNumbersToLinkedList(b);

  equal = LinkedListNumbersEqual(aa, ba);

  if( !equal ){
    failures.numberValue = failures.numberValue + 1;
  }

  newb = LinkedListToDynamicArrayNumbers(ba);

  equal = DynamicArrayNumbersEqual(a, newb);

  if( !equal ){
    failures.numberValue = failures.numberValue + 1;
  }
}
function TestDynamicArrayNumbersEqualsAndConvert4(failures){
  var a, b, newb;
  var aa, ba;
  var equal;

  a = CreateDynamicArrayNumbers();

  DynamicArrayInsertNumber(a, 0, 1);
  DynamicArrayInsertNumber(a, 0, 2);
  DynamicArrayInsertNumber(a, 0, 3);

  b = CreateDynamicArrayNumbers();

  DynamicArrayInsertNumber(b, 0, 3);
  DynamicArrayInsertNumber(b, 0, 2);
  DynamicArrayInsertNumber(b, 2, 1);

  equal = DynamicArrayNumbersEqual(a, b);

  if(equal){
    failures.numberValue = failures.numberValue + 1;
  }

  aa = DynamicArrayNumbersToLinkedList(a);
  ba = DynamicArrayNumbersToLinkedList(b);

  equal = LinkedListNumbersEqual(aa, ba);

  if(equal){
    failures.numberValue = failures.numberValue + 1;
  }

  newb = LinkedListToDynamicArrayNumbers(ba);

  equal = DynamicArrayNumbersEqual(a, newb);

  if(equal){
    failures.numberValue = failures.numberValue + 1;
  }
}
function testStringList1(failures){
  var list;
  var stringReference1, stringReference2, stringReference3;

  list = [];
  list.length = 0;

  stringReference1 = CreateStringReference("hei1".split(''));
  stringReference2 = CreateStringReference("hei2".split(''));
  stringReference3 = CreateStringReference("hei3".split(''));
  list = AddString(list, stringReference1);
  list = AddString(list, stringReference2);
  list = AddString(list, stringReference3);
		
  if( !StringsEqual(list[0].string, "hei1".split('')) ){
    failures.numberValue = failures.numberValue + 1;
  }
  if( !StringsEqual(list[1].string, "hei2".split('')) ){
    failures.numberValue = failures.numberValue + 1;
  }
  if( !StringsEqual(list[2].string, "hei3".split('')) ){
    failures.numberValue = failures.numberValue + 1;
  }
		
  list = RemoveString(list, 1);
		
  if( !StringsEqual(list[0].string, "hei1".split('')) ){
    failures.numberValue = failures.numberValue + 1;
  }
  if( !StringsEqual(list[1].string, "hei3".split('')) ){
    failures.numberValue = failures.numberValue + 1;
  }
		
  delete(list);
}
function testStringList2(failures){
  var list;
  var stringReference1, stringReference2, stringReference3;

  list = {};
  list.stringArray = [];
  list.stringArray.length = 0;

  stringReference1 = CreateStringReference("hei1".split(''));
  stringReference2 = CreateStringReference("hei2".split(''));
  stringReference3 = CreateStringReference("hei3".split(''));

  AddStringRef(list, stringReference1);
  AddStringRef(list, stringReference2);
  AddStringRef(list, stringReference3);

  if( !StringsEqual(GetStringRef(list, 0).string, "hei1".split('')) ){
    failures.numberValue = failures.numberValue + 1;
  }
  if( !StringsEqual(GetStringRef(list, 1).string, "hei2".split('')) ){
    failures.numberValue = failures.numberValue + 1;
  }
  if( !StringsEqual(GetStringRef(list, 2).string, "hei3".split('')) ){
    failures.numberValue = failures.numberValue + 1;
  }

  RemoveStringRef(list, 1);

  if( !StringsEqual(GetStringRef(list, 0).string, "hei1".split('')) ){
    failures.numberValue = failures.numberValue + 1;
  }
  if( !StringsEqual(GetStringRef(list, 1).string, "hei3".split('')) ){
    failures.numberValue = failures.numberValue + 1;
  }

  delete(list);
}
function test(){
  var failures;

  failures = CreateNumberReference(0);

  testNumberList1(failures);
  testNumberList2(failures);
  testStringList1(failures);
  testStringList2(failures);
  LinkedListTests(failures);
  DynamicArrayTests(failures);

  return failures.numberValue;
}
function LinkedListTests(failures){
  TestAdd(failures);
  TestRemove1(failures);
  TestRemove2(failures);
  TestRemove3(failures);
  TestInsert(failures);
  TestEqualsAndConvert1(failures);
  TestEqualsAndConvert2(failures);
}
function TestAdd(failures){
  var ll;

  ll = CreateLinkedListNumbers();

  LinkedListAddNumber(ll, 1);
  LinkedListAddNumber(ll, 2);
  LinkedListAddNumber(ll, 3);

  if(LinkedListNumbersLength(ll) != 3){
    failures.numberValue = failures.numberValue + 1;
  }

  if(LinkedListNumbersIndex(ll, 0) != 1){
    failures.numberValue = failures.numberValue + 1;
  }

  if(LinkedListNumbersIndex(ll, 1) != 2){
    failures.numberValue = failures.numberValue + 1;
  }

  if(LinkedListNumbersIndex(ll, 2) != 3){
    failures.numberValue = failures.numberValue + 1;
  }

  if(ll.first.next.next.next.end != true && ll.last.end != true){
    failures.numberValue = failures.numberValue + 1;
  }

  FreeLinkedListNumbers(ll);
}
function TestRemove1(failures){
  var ll;

  ll = CreateLinkedListNumbers();

  LinkedListAddNumber(ll, 1);
  LinkedListAddNumber(ll, 2);
  LinkedListAddNumber(ll, 3);
  LinkedListRemoveNumber(ll, 2);

  if(LinkedListNumbersLength(ll) != 2){
    failures.numberValue = failures.numberValue + 1;
  }

  if(LinkedListNumbersIndex(ll, 0) != 1){
    failures.numberValue = failures.numberValue + 1;
  }

  if(LinkedListNumbersIndex(ll, 1) != 2){
    failures.numberValue = failures.numberValue + 1;
  }

  if(ll.first.next.next.end != true && ll.last.end != true){
    failures.numberValue = failures.numberValue + 1;
  }

  FreeLinkedListNumbers(ll);
}
function TestRemove2(failures){
  var ll;

  ll = CreateLinkedListNumbers();

  LinkedListAddNumber(ll, 1);
  LinkedListAddNumber(ll, 2);
  LinkedListAddNumber(ll, 3);
  LinkedListRemoveNumber(ll, 1);

  if(LinkedListNumbersLength(ll) != 2){
    failures.numberValue = failures.numberValue + 1;
  }

  if(LinkedListNumbersIndex(ll, 0) != 1){
    failures.numberValue = failures.numberValue + 1;
  }

  if(LinkedListNumbersIndex(ll, 1) != 3){
    failures.numberValue = failures.numberValue + 1;
  }

  if(ll.first.next.next.end != true && ll.last.end != true){
    failures.numberValue = failures.numberValue + 1;
  }

  FreeLinkedListNumbers(ll);
}
function TestRemove3(failures){
  var ll;

  ll = CreateLinkedListNumbers();

  LinkedListAddNumber(ll, 1);
  LinkedListAddNumber(ll, 2);
  LinkedListAddNumber(ll, 3);
  LinkedListRemoveNumber(ll, 0);
  LinkedListRemoveNumber(ll, 1);
  LinkedListRemoveNumber(ll, 0);

  if(LinkedListNumbersLength(ll) != 0){
    failures.numberValue = failures.numberValue + 1;
  }

  if(ll.first.end != true && ll.last.end != true){
    failures.numberValue = failures.numberValue + 1;
  }

  FreeLinkedListNumbers(ll);
}
function TestInsert(failures){
  var ll;

  ll = CreateLinkedListNumbers();

  LinkedListInsertNumber(ll, 0, 1);
  LinkedListInsertNumber(ll, 0, 2);
  LinkedListInsertNumber(ll, 0, 3);

  if(LinkedListNumbersLength(ll) != 3){
    failures.numberValue = failures.numberValue + 1;
  }

  if(LinkedListNumbersIndex(ll, 0) != 3){
    failures.numberValue = failures.numberValue + 1;
  }

  if(LinkedListNumbersIndex(ll, 1) != 2){
    failures.numberValue = failures.numberValue + 1;
  }

  if(LinkedListNumbersIndex(ll, 2) != 1){
    failures.numberValue = failures.numberValue + 1;
  }

  if(ll.first.next.next.next.end != true && ll.last.end != true){
    failures.numberValue = failures.numberValue + 1;
  }

  FreeLinkedListNumbers(ll);
}
function TestEqualsAndConvert1(failures){
  var a, b, newb;
  var aa, ba;
  var equal;

  a = CreateLinkedListNumbers();

  LinkedListInsertNumber(a, 0, 1);
  LinkedListInsertNumber(a, 0, 2);
  LinkedListInsertNumber(a, 0, 3);

  b = CreateLinkedListNumbers();

  LinkedListInsertNumber(b, 0, 3);
  LinkedListInsertNumber(b, 1, 2);
  LinkedListInsertNumber(b, 2, 1);

  equal = LinkedListNumbersEqual(a, b);

  if( !equal ){
    failures.numberValue = failures.numberValue + 1;
  }

  aa = LinkedListNumbersToArray(a);
  ba = LinkedListNumbersToArray(b);

  equal = NumberArraysEqual(aa, ba);

  if( !equal ){
    failures.numberValue = failures.numberValue + 1;
  }

  newb = ArrayToLinkedListNumbers(ba);

  equal = LinkedListNumbersEqual(a, newb);

  if( !equal ){
    failures.numberValue = failures.numberValue + 1;
  }
}
function TestEqualsAndConvert2(failures){
  var a, b, newb;
  var aa, ba;
  var equal;

  a = CreateLinkedListNumbers();

  LinkedListInsertNumber(a, 0, 1);
  LinkedListInsertNumber(a, 0, 2);
  LinkedListInsertNumber(a, 0, 3);

  b = CreateLinkedListNumbers();

  LinkedListInsertNumber(b, 0, 3);
  LinkedListInsertNumber(b, 0, 2);
  LinkedListInsertNumber(b, 2, 1);

  equal = LinkedListNumbersEqual(a, b);

  if(equal){
    failures.numberValue = failures.numberValue + 1;
  }

  aa = LinkedListNumbersToArray(a);
  ba = LinkedListNumbersToArray(b);

  equal = NumberArraysEqual(aa, ba);

  if(equal){
    failures.numberValue = failures.numberValue + 1;
  }

  newb = ArrayToLinkedListNumbers(ba);

  equal = LinkedListNumbersEqual(a, newb);

  if(equal){
    failures.numberValue = failures.numberValue + 1;
  }
}
function CreateBooleanReference(value){
  var ref;

  ref = {};
  ref.booleanValue = value;

  return ref;
}
function CreateBooleanArrayReference(value){
  var ref;

  ref = {};
  ref.booleanArray = value;

  return ref;
}
function CreateBooleanArrayReferenceLengthValue(lengthx, value){
  var ref;
  var i;

  ref = {};
  ref.booleanArray = [];
  ref.booleanArray.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    ref.booleanArray[i] = value;
  }

  return ref;
}
function FreeBooleanArrayReference(booleanArrayReference){
  delete(booleanArrayReference.booleanArray);
  delete(booleanArrayReference);
}
function CreateCharacterReference(value){
  var ref;

  ref = {};
  ref.characterValue = value;

  return ref;
}
function CreateNumberReference(value){
  var ref;

  ref = {};
  ref.numberValue = value;

  return ref;
}
function CreateNumberArrayReference(value){
  var ref;

  ref = {};
  ref.numberArray = value;

  return ref;
}
function CreateNumberArrayReferenceLengthValue(lengthx, value){
  var ref;
  var i;

  ref = {};
  ref.numberArray = [];
  ref.numberArray.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    ref.numberArray[i] = value;
  }

  return ref;
}
function FreeNumberArrayReference(numberArrayReference){
  delete(numberArrayReference.numberArray);
  delete(numberArrayReference);
}
function CreateStringReference(value){
  var ref;

  ref = {};
  ref.string = value;

  return ref;
}
function CreateStringReferenceLengthValue(lengthx, value){
  var ref;
  var i;

  ref = {};
  ref.string = [];
  ref.string.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    ref.string[i] = value;
  }

  return ref;
}
function FreeStringReference(stringReference){
  delete(stringReference.string);
  delete(stringReference);
}
function CreateStringArrayReference(strings){
  var ref;

  ref = {};
  ref.stringArray = strings;

  return ref;
}
function CreateStringArrayReferenceLengthValue(lengthx, value){
  var ref;
  var i;

  ref = {};
  ref.stringArray = [];
  ref.stringArray.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    ref.stringArray[i] = CreateStringReference(value);
  }

  return ref;
}
function FreeStringArrayReference(stringArrayReference){
  var i;

  for(i = 0; i < stringArrayReference.stringArray.length; i = i + 1){
    delete(stringArrayReference.stringArray[i]);
  }
  delete(stringArrayReference.stringArray);
  delete(stringArrayReference);
}
function StringToNumberArray(string){
  var i;
  var array;

  array = [];
  array.length = string.length;

  for(i = 0; i < string.length; i = i + 1){
    array[i] = string[i].charCodeAt(0);
  }
  return array;
}
function NumberArrayToString(array){
  var i;
  var string;

  string = [];
  string.length = array.length;

  for(i = 0; i < array.length; i = i + 1){
    string[i] = String.fromCharCode(array[i]);
  }
  return string;
}
function NumberArraysEqual(a, b){
  var equal;
  var i;

  equal = true;
  if(a.length == b.length){
    for(i = 0; i < a.length && equal; i = i + 1){
      if(a[i] != b[i]){
        equal = false;
      }
    }
  }else{
    equal = false;
  }

  return equal;
}
function BooleanArraysEqual(a, b){
  var equal;
  var i;

  equal = true;
  if(a.length == b.length){
    for(i = 0; i < a.length && equal; i = i + 1){
      if(a[i] != b[i]){
        equal = false;
      }
    }
  }else{
    equal = false;
  }

  return equal;
}
function StringsEqual(a, b){
  var equal;
  var i;

  equal = true;
  if(a.length == b.length){
    for(i = 0; i < a.length && equal; i = i + 1){
      if(a[i] != b[i]){
        equal = false;
      }
    }
  }else{
    equal = false;
  }

  return equal;
}
function FillNumberArray(a, value){
  var i;

  for(i = 0; i < a.length; i = i + 1){
    a[i] = value;
  }
}
function FillString(a, value){
  var i;

  for(i = 0; i < a.length; i = i + 1){
    a[i] = value;
  }
}
function FillBooleanArray(a, value){
  var i;

  for(i = 0; i < a.length; i = i + 1){
    a[i] = value;
  }
}
function FillNumberArrayRange(a, value, from, to){
  var i, lengthx;
  var success;

  if(from >= 0 && from <= a.length && to >= 0 && to <= a.length && from <= to){
    lengthx = to - from;
    for(i = 0; i < lengthx; i = i + 1){
      a[from + i] = value;
    }

    success = true;
  }else{
    success = false;
  }

  return success;
}
function FillBooleanArrayRange(a, value, from, to){
  var i, lengthx;
  var success;

  if(from >= 0 && from <= a.length && to >= 0 && to <= a.length && from <= to){
    lengthx = to - from;
    for(i = 0; i < lengthx; i = i + 1){
      a[from + i] = value;
    }

    success = true;
  }else{
    success = false;
  }

  return success;
}
function FillStringRange(a, value, from, to){
  var i, lengthx;
  var success;

  if(from >= 0 && from <= a.length && to >= 0 && to <= a.length && from <= to){
    lengthx = to - from;
    for(i = 0; i < lengthx; i = i + 1){
      a[from + i] = value;
    }

    success = true;
  }else{
    success = false;
  }

  return success;
}
function CopyNumberArray(a){
  var i;
  var n;

  n = [];
  n.length = a.length;

  for(i = 0; i < a.length; i = i + 1){
    n[i] = a[i];
  }

  return n;
}
function CopyBooleanArray(a){
  var i;
  var n;

  n = [];
  n.length = a.length;

  for(i = 0; i < a.length; i = i + 1){
    n[i] = a[i];
  }

  return n;
}
function CopyString(a){
  var i;
  var n;

  n = [];
  n.length = a.length;

  for(i = 0; i < a.length; i = i + 1){
    n[i] = a[i];
  }

  return n;
}
function CopyNumberArrayRange(a, from, to, copyReference){
  var i, lengthx;
  var n;
  var success;

  if(from >= 0 && from <= a.length && to >= 0 && to <= a.length && from <= to){
    lengthx = to - from;
    n = [];
    n.length = lengthx;

    for(i = 0; i < lengthx; i = i + 1){
      n[i] = a[from + i];
    }

    copyReference.numberArray = n;
    success = true;
  }else{
    success = false;
  }

  return success;
}
function CopyBooleanArrayRange(a, from, to, copyReference){
  var i, lengthx;
  var n;
  var success;

  if(from >= 0 && from <= a.length && to >= 0 && to <= a.length && from <= to){
    lengthx = to - from;
    n = [];
    n.length = lengthx;

    for(i = 0; i < lengthx; i = i + 1){
      n[i] = a[from + i];
    }

    copyReference.booleanArray = n;
    success = true;
  }else{
    success = false;
  }

  return success;
}
function CopyStringRange(a, from, to, copyReference){
  var i, lengthx;
  var n;
  var success;

  if(from >= 0 && from <= a.length && to >= 0 && to <= a.length && from <= to){
    lengthx = to - from;
    n = [];
    n.length = lengthx;

    for(i = 0; i < lengthx; i = i + 1){
      n[i] = a[from + i];
    }

    copyReference.string = n;
    success = true;
  }else{
    success = false;
  }

  return success;
}
function IsLastElement(lengthx, index){
  return index + 1 == lengthx;
}
function CreateNumberArray(lengthx, value){
  var array;

  array = [];
  array.length = lengthx;
  FillNumberArray(array, value);

  return array;
}
function CreateBooleanArray(lengthx, value){
  var array;

  array = [];
  array.length = lengthx;
  FillBooleanArray(array, value);

  return array;
}
function CreateString(lengthx, value){
  var array;

  array = [];
  array.length = lengthx;
  FillString(array, value);

  return array;
}
function SwapElementsOfNumberArray(A, ai, bi){
  var tmp;

  tmp = A[ai];
  A[ai] = A[bi];
  A[bi] = tmp;
}
function SwapElementsOfStringArray(A, ai, bi){
  var tmp;

  tmp = A.stringArray[ai];
  A.stringArray[ai] = A.stringArray[bi];
  A.stringArray[bi] = tmp;
}
function ReverseNumberArray(array){
  var i;

  for(i = 0; i < array.length/2; i = i + 1){
    SwapElementsOfNumberArray(array, i, array.length - i - 1);
  }
}


module.exports = {
	AddNumber: AddNumber,
	AddNumberRef: AddNumberRef,
	RemoveNumber: RemoveNumber,
	GetNumberRef: GetNumberRef,
	RemoveNumberRef: RemoveNumberRef,
	AddString: AddString,
	AddStringRef: AddStringRef,
	RemoveString: RemoveString,
	GetStringRef: GetStringRef,
	RemoveStringRef: RemoveStringRef,
	CreateDynamicArrayCharacters: CreateDynamicArrayCharacters,
	CreateDynamicArrayCharactersWithInitialCapacity: CreateDynamicArrayCharactersWithInitialCapacity,
	DynamicArrayAddCharacter: DynamicArrayAddCharacter,
	DynamicArrayAddString: DynamicArrayAddString,
	DynamicArrayCharactersIncreaseSize: DynamicArrayCharactersIncreaseSize,
	DynamicArrayCharactersDecreaseSizeNecessary: DynamicArrayCharactersDecreaseSizeNecessary,
	DynamicArrayCharactersDecreaseSize: DynamicArrayCharactersDecreaseSize,
	DynamicArrayCharactersIndex: DynamicArrayCharactersIndex,
	DynamicArrayCharactersLength: DynamicArrayCharactersLength,
	DynamicArrayInsertCharacter: DynamicArrayInsertCharacter,
	DynamicArrayCharacterSet: DynamicArrayCharacterSet,
	DynamicArrayRemoveCharacter: DynamicArrayRemoveCharacter,
	FreeDynamicArrayCharacters: FreeDynamicArrayCharacters,
	DynamicArrayCharactersToArray: DynamicArrayCharactersToArray,
	ArrayToDynamicArrayCharactersWithOptimalSize: ArrayToDynamicArrayCharactersWithOptimalSize,
	ArrayToDynamicArrayCharacters: ArrayToDynamicArrayCharacters,
	DynamicArrayCharactersEqual: DynamicArrayCharactersEqual,
	DynamicArrayCharactersToLinkedList: DynamicArrayCharactersToLinkedList,
	LinkedListToDynamicArrayCharacters: LinkedListToDynamicArrayCharacters,
	AddBoolean: AddBoolean,
	AddBooleanRef: AddBooleanRef,
	RemoveBoolean: RemoveBoolean,
	GetBooleanRef: GetBooleanRef,
	RemoveDecimalRef: RemoveDecimalRef,
	CreateLinkedListString: CreateLinkedListString,
	LinkedListAddString: LinkedListAddString,
	LinkedListStringsToArray: LinkedListStringsToArray,
	LinkedListStringsLength: LinkedListStringsLength,
	FreeLinkedListString: FreeLinkedListString,
	LinkedListInsertString: LinkedListInsertString,
	CreateLinkedListNumbers: CreateLinkedListNumbers,
	CreateLinkedListNumbersArray: CreateLinkedListNumbersArray,
	LinkedListAddNumber: LinkedListAddNumber,
	LinkedListNumbersLength: LinkedListNumbersLength,
	LinkedListNumbersIndex: LinkedListNumbersIndex,
	LinkedListInsertNumber: LinkedListInsertNumber,
	LinkedListSet: LinkedListSet,
	LinkedListRemoveNumber: LinkedListRemoveNumber,
	FreeLinkedListNumbers: FreeLinkedListNumbers,
	FreeLinkedListNumbersArray: FreeLinkedListNumbersArray,
	LinkedListNumbersToArray: LinkedListNumbersToArray,
	ArrayToLinkedListNumbers: ArrayToLinkedListNumbers,
	LinkedListNumbersEqual: LinkedListNumbersEqual,
	CreateLinkedListCharacter: CreateLinkedListCharacter,
	LinkedListAddCharacter: LinkedListAddCharacter,
	LinkedListCharactersToArray: LinkedListCharactersToArray,
	LinkedListCharactersLength: LinkedListCharactersLength,
	FreeLinkedListCharacter: FreeLinkedListCharacter,
	LinkedListCharactersAddString: LinkedListCharactersAddString,
	LinkedListInsertCharacter: LinkedListInsertCharacter,
	CreateDynamicArrayNumbers: CreateDynamicArrayNumbers,
	CreateDynamicArrayNumbersWithInitialCapacity: CreateDynamicArrayNumbersWithInitialCapacity,
	DynamicArrayAddNumber: DynamicArrayAddNumber,
	DynamicArrayNumbersIncreaseSize: DynamicArrayNumbersIncreaseSize,
	DynamicArrayNumbersDecreaseSizeNecessary: DynamicArrayNumbersDecreaseSizeNecessary,
	DynamicArrayNumbersDecreaseSize: DynamicArrayNumbersDecreaseSize,
	DynamicArrayNumbersIndex: DynamicArrayNumbersIndex,
	DynamicArrayNumbersLength: DynamicArrayNumbersLength,
	DynamicArrayInsertNumber: DynamicArrayInsertNumber,
	DynamicArrayNumberSet: DynamicArrayNumberSet,
	DynamicArrayRemoveNumber: DynamicArrayRemoveNumber,
	FreeDynamicArrayNumbers: FreeDynamicArrayNumbers,
	DynamicArrayNumbersToArray: DynamicArrayNumbersToArray,
	ArrayToDynamicArrayNumbersWithOptimalSize: ArrayToDynamicArrayNumbersWithOptimalSize,
	ArrayToDynamicArrayNumbers: ArrayToDynamicArrayNumbers,
	DynamicArrayNumbersEqual: DynamicArrayNumbersEqual,
	DynamicArrayNumbersToLinkedList: DynamicArrayNumbersToLinkedList,
	LinkedListToDynamicArrayNumbers: LinkedListToDynamicArrayNumbers,
	DynamicArrayNumbersIndexOf: DynamicArrayNumbersIndexOf,
	DynamicArrayNumbersIsInArray: DynamicArrayNumbersIsInArray,
	AddCharacter: AddCharacter,
	AddCharacterRef: AddCharacterRef,
	RemoveCharacter: RemoveCharacter,
	GetCharacterRef: GetCharacterRef,
	RemoveCharacterRef: RemoveCharacterRef,
	CreateBooleanReference: CreateBooleanReference,
	CreateBooleanArrayReference: CreateBooleanArrayReference,
	CreateBooleanArrayReferenceLengthValue: CreateBooleanArrayReferenceLengthValue,
	FreeBooleanArrayReference: FreeBooleanArrayReference,
	CreateCharacterReference: CreateCharacterReference,
	CreateNumberReference: CreateNumberReference,
	CreateNumberArrayReference: CreateNumberArrayReference,
	CreateNumberArrayReferenceLengthValue: CreateNumberArrayReferenceLengthValue,
	FreeNumberArrayReference: FreeNumberArrayReference,
	CreateStringReference: CreateStringReference,
	CreateStringReferenceLengthValue: CreateStringReferenceLengthValue,
	FreeStringReference: FreeStringReference,
	CreateStringArrayReference: CreateStringArrayReference,
	CreateStringArrayReferenceLengthValue: CreateStringArrayReferenceLengthValue,
	FreeStringArrayReference: FreeStringArrayReference,
	StringToNumberArray: StringToNumberArray,
	NumberArrayToString: NumberArrayToString,
	NumberArraysEqual: NumberArraysEqual,
	BooleanArraysEqual: BooleanArraysEqual,
	StringsEqual: StringsEqual,
	FillNumberArray: FillNumberArray,
	FillString: FillString,
	FillBooleanArray: FillBooleanArray,
	FillNumberArrayRange: FillNumberArrayRange,
	FillBooleanArrayRange: FillBooleanArrayRange,
	FillStringRange: FillStringRange,
	CopyNumberArray: CopyNumberArray,
	CopyBooleanArray: CopyBooleanArray,
	CopyString: CopyString,
	CopyNumberArrayRange: CopyNumberArrayRange,
	CopyBooleanArrayRange: CopyBooleanArrayRange,
	CopyStringRange: CopyStringRange,
	IsLastElement: IsLastElement,
	CreateNumberArray: CreateNumberArray,
	CreateBooleanArray: CreateBooleanArray,
	CreateString: CreateString,
	SwapElementsOfNumberArray: SwapElementsOfNumberArray,
	SwapElementsOfStringArray: SwapElementsOfStringArray,
	ReverseNumberArray: ReverseNumberArray,
	test: test
};